/*
    This file is a part of the SteamWar software.

    Copyright (C) 2020  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

package de.steamwar.core;

import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.BaseComponent;
import org.bukkit.entity.Player;

import java.util.UUID;

public class BountifulWrapper {
    private BountifulWrapper() {}

    public static final IBountifulWrapper impl = VersionDependent.getVersionImpl(Core.getInstance());

    public interface IBountifulWrapper {
        void playPling(Player player);

        void sendMessage(Player player, ChatMessageType type, BaseComponent... msg);

        Object getDataWatcherObject(int index, Class<?> type);
        Object getDataWatcherItem(Object dataWatcherObject, Object value);

        PositionSetter getPositionSetter(Class<?> packetClass, int fieldOffset);
        PositionSetter getRelMoveSetter(Class<?> packetClass);
        UUIDSetter getUUIDSetter(Class<?> packetClass);
    }

    public interface PositionSetter {
        void set(Object packet, double x, double y, double z, float pitch, float yaw);
    }

    public interface UUIDSetter {
        void set(Object packet, UUID uuid);
    }
}
